rem $$asmb=win1_uti_dsk_sts_asm_Stats_bin,0,10
rem $$asmb=dev4_dsk_MD_BIN,0,10
:
ext_proc 'SCRXY', 'WINDSZ'
ext_fn 'VALID%', 'ODD', 'DETAB$', 'MEN_STATS'
ext_fn 'MDFSIZE', 'MDFREE', 'MDGOOD', 'MDFHEAD', 'MDALLOC'
:
rem + ######################################################################## +
rem #<                                 Stats                                  >#
rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
rem #                         Display drive statistics                         #
rem #                                                                          #
rem # Stand alone version                                                      #
rem # Works with Qdos directory devices, but not DOS/NFA etc                   #
rem # Problem with display of "Free" text (eg in pal 2): Contrast!             #
rem + ------------------------------------------------------------------------ +
rem # V0.01, pjw, 1998, 2oo2+, Part of Qwirc 1                                 #
rem # V0.02, pjw, 2020 Feb 14, Changed Sz$ from 7 to 8 digits, => min W = 250  #
rem # V0.03, pjw, 2024 Apr 24, Qlib CDEC$ overflows where SBASIC doesnt! Fixed #
rem #                          Added frame around bar for WL ;o)               #
rem + ######################################################################## +
:
scrxy mx_wnx%, mx_wny%:         rem Max display
:
aw_title%       =  1
aw_disp%        =  2
:
sp_titlebg%     = 516: rem Title background
sp_titletextbg% = 517: rem Title text background
sp_titlefg%     = 518: rem Title foreground
sp_litemhigh%   = 519: rem Loose item highlight
sp_litemavafg%  = 521: rem Loose item available foreground
sp_litemselbg%  = 522: rem Loose item selected background
sp_litemselfg%  = 523: rem Loose item selected foreground
sp_infwinbg%    = 527: rem Information window background
sp_infwinfg%    = 528: rem Information window foreground
sp_infwinmg%    = 529: rem Information window middleground
sp_subinfbg%    = 531: rem Subsidiary information window background
sp_subinffg%    = 532: rem Subsidiary information window foreground
:
tv%             =  1: rem Return on keypress
kb = 2 ^ 10: mb = 2 ^ 20 : gb = 2 ^ 30:         rem MB conversion
mbb = 100 / mb: gbb = 100 / mb: tbb = 100 / gb
quote$          = '"' & "'"
mn_wnx%         = 250: rem Min window sizes
mn_wny%         = 129: rem (fixed)
mx_wnx%         = mx_wnx% - 20
:
cl$ = CMD$
:
rem $$off
if peek$(\\ -4, 4) = 'SBAS' then
 lrespr 'dev1_qwc_asm_Stats_bin'
 lrespr'win4_dsk_MD_BIN': rem lrespr 'dev1_qwc_asm_MD_bin'
 rem MEN_STATS = ldata("dev1_qwc_ptr_Stats_men")
 if cl$ = '': cl$ = '/Dwin3_ /P3 /X500 /Y20 /W400'
endif
rem $$on
:
er = GetCmd(cl$): if er < 0: quit er
:
ch = fopen("con")
mdraw#ch; MEN_STATS, xpos%, ypos%, wide%, mn_wny%
Title#ch; aw_title%, 'Stats for ' & win$
:
adx   = wide% / mn_wnx%: rem Rudimentary scaling..
col1% =  40 * adx
col2% =  92 * adx
col3% = 156 * adx
row1% =  15
row2% =  28
row3% =  41
row4% =  54
row5% =  69
:
Draw_Display
er = GetStats(ch, win$)
Updt_Display
if er < 0: Burp: else: Ping
x% = -1: y% = x%
rep main
 windsz#ch; xs%, ys%, xo%, yo%:         rem Window origin
 rdpt#ch, tv%, x%, y%:                  rem Pointer position
 dx% = x% - xo%: dy% = y% - yo%:        rem Relative pointer position in window
 k% = tv% div 256
 sel on k%
  =   1: wmov#ch; -1
  =   2, 27: exit main
  = -11: wmov#ch
  = remainder: Burp: next main
 endsel
 windsz#ch; xs%, ys%, xo%, yo%:         rem Window origin
 x% = xo% + dx%: y% = yo% + dy%:        rem Restore relative pointer position
endrep main
ptop#ch; ojob(-1): quit er:             rem Restore owner to top of pile
:
:
def proc Draw_Display
mwindow#ch; aw_disp%
wm_ink#ch; sp_infwinmg%: wm_strip#ch; sp_infwinbg%
cursor#ch; col1%, 2: bput#ch; Center$('No.', 7)
cursor#ch; col2%, 2: bput#ch; Center$('Size', 9)
cursor#ch; col3%, 2: bput#ch; Center$('Using', 9)
cursor#ch; 2, row1%: bput#ch; 'Dirs '
cursor#ch; 2, row2%: bput#ch; 'Files'
cursor#ch; 2, row3%: bput#ch; 'Total'
cursor#ch; 2, row4%: bput#ch; 'Alloc'
cursor#ch; col1%, row5%: bput#ch; 'Data '
cursor#ch; col2%, row5%: bput#ch; 'Using '
cursor#ch; col3%, row5%: bput#ch; 'Free '
:
wm_ink#ch; sp_infwinfg%: wm_strip#ch; sp_infwinbg%
cursor#ch; 2, row5%: bput#ch; 'Key: '
wm_block#ch; 14, 12, col1% + 28, row5% - 1, sp_litemhigh%
wm_block#ch; 14, 12, col2% + 34, row5% - 1, sp_litemhigh%
wm_block#ch; 14, 12, col3% + 28, row5% - 1, sp_litemhigh%
:
wm_block#ch; 10, 10, col1% + 30, row5%, sp_litemselfg%: rem Data
wm_block#ch; 10, 10, col2% + 36, row5%, sp_litemselbg%: rem Using
wm_block#ch; 10, 10, col3% + 30, row5%, sp_litemavafg%: rem Free
enddef Draw_Display
:
:
def proc Updt_Display
mwindow#ch; aw_disp%
wm_ink#ch; sp_infwinfg%: wm_strip#ch; sp_infwinbg%
cursor#ch; col1%, row1%: bput#ch; cdec$(NoDirs, 7, 0)
cursor#ch; col1%, row2%: bput#ch; cdec$(NoFiles, 7, 0)
cursor#ch; col1%, row3%: bput#ch; cdec$(NoDirs + NoFiles, 7, 0)
cursor#ch; col1%, row4%: bput#ch; cdec$(alloc, 7, 0)
:
cursor#ch; col2%, row1%: bput#ch; Sz$(DirSize)
cursor#ch; col2%, row2%: bput#ch; Sz$(FileSize)
cursor#ch; col2%, row3%: bput#ch; Sz$(TotalSize)
:
cursor#ch; col3%, row1%: bput#ch; Sz$(DirRoom)
cursor#ch; col3%, row2%: bput#ch; Sz$(FileRoom)
cursor#ch; col3%, row3%: bput#ch; Sz$(TotalRoom)
cursor#ch; col3%, row4%: bput#ch; Sz$(FreeSpace)
:
wm_ink#ch; sp_litemselfg%: wm_strip#ch; sp_litemavabg%
cursor#ch; col2%, row4%: bput#ch; '     Free:'
enddef Updt_Display
:
:
rem + ------------------------------------------------------------------------ +
rem |<                                GetStats                                >|
rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
rem |              Scan drive for file sizes and space usage data              |
rem |                                                                          |
rem | External: WINDSZ                                                         |
rem + ------------------------------------------------------------------------ +
rem | VQ.03, PWitte 1998, 2oo2                                                 |
rem | V0.04, pjw, 2020 Feb 13, Variable bar size, no functional change         |
rem + ------------------------------------------------------------------------ +
:
DEFine FuNction GetStats(cd, dev$)
LOCal ld, lf, c%, t%, pos, chan%(19), chl(19), n$(36)
LOCal er, leng, room, fhead, notch, unit
LOCal k%, xs%, ys%, x%, y%
:
rem Init LOCals:
n$              = ''
c%              = 0
er              = 0
notch           = 0
:
rem Init GLOBals:
NoDirs          = 0
NoFiles         = 0
DirSize         = 0
DirRoom         = 0
FileSize        = 0
FileRoom        = 0
TotalSize       = 0
TotalRoom       = 0
:
mwindow#cd; aw_disp%
windsz#cd; xs%, ys%, x%, y%
barx% = xs% -  8
bary% = ys% - 24
wm_block#cd; barx% + 4, 20, 2, bary% - 1, sp_litemhigh%: rem Frame
wm_block#cd; barx%, 18, 4, bary%, sp_litemavafg%:        rem Disk size
x% = -1: y% = x%
:
er = fop_in(dev$): if er < 0: ret er
fhead           = mdfhead(#er)
unit            = mdgood(#er) / barx%
alloc           = mdalloc(#er)
FreeSpace       = mdfree(#er)
close#er
:
REPeat ld
 er = FOP_DIR(dev$ & n$)
 IF er < 0 THEN
  IF er = -9 THEN
   c% = c% - 1: IF c% < 0: EXIT ld
   NEXT ld
  END IF
  EXIT ld
 END IF
 chan%(c%) = er: chl(c%) = flen(#er): pos = -64
 REPeat lf
  pos = pos + 64
  IF pos >= chl(c%) THEN
   n$ = FNAME$(#chan%(c%)): CLOSE#chan%(c%)
   c% = c% - 1: IF c% < 0: EXIT ld
   pos = INT(FPOS(#chan%(c%)) / 64) * 64
  ELSE
   GET#chan%(c%)\ pos + 14; n$
   IF LEN(n$) > 0 THEN
    LGET#chan%(c%)\ pos + 0, leng: leng = leng - fhead
    BGET#chan%(c%)\ pos + 5; t%
    IF t% = 255 THEN
     :
     rem Emergency exit
     rdpt#cd; tv%, x%, y%, 0
     if tv% <> 1 then
      rdpt#ch; tv%, x%, y%
      k% = tv% div 256
      sel on k%
       = 2, 10, 27: CloseAll: er = -1: Burp: exit ld
      endsel
      Ping
     endif
     :
     room = mdfsize(#chan%(c%), leng)
     NoDirs = NoDirs + 1
     DirSize = DirSize + leng
     DirRoom = DirRoom + room
     BarInc
     c% = c% + 1: EXIT lf
    ELSE
     room = mdfsize(#chan%(c%), leng)
     NoFiles = NoFiles + 1
     FileSize = FileSize + leng
     FileRoom = FileRoom + room
     BarInc
    END IF
   END IF
  END IF
 END REPeat lf
END REPeat ld
RETurn er
END DEFine
:
def proc BarInc
TotalSize = TotalSize + leng
TotalRoom = TotalRoom + room
notch = notch + room
IF notch >= unit THEN
 WM_BLOCK#cd; TotalRoom / unit , 14, 4, bary% + 2, sp_litemselbg%
 WM_BLOCK#cd; TotalSize / unit, 10, 4, bary% + 4, sp_litemselfg%
 notch = 0
END IF
enddef BarInc
:
def proc CloseAll
loc cal
rep cal
 if c% < 0: exit cal
 if chan%(c%) > 0: close#chan%(c%)
 c% = c% - 1
end repeat cal
enddef
:
:
:
rem + ************************************************************************ +
rem *<                      Miscellaneous Help Routines                       >*
rem + ************************************************************************ +
:
:
rem + ------------------------------------------------------------------------ +
rem |<                                 Title                                  >|
rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
rem |                   Displays a given title on title bar                    |
rem |                                                                          |
rem | Assumes centered Application Window as title bar. Also assumes text fits |
rem | Hardwired background is 13 pix, csize 0,0                                |
rem |                                                                          |
rem |                 Modify as appropriate to circumstances!                  |
rem |                                                                          |
rem | External: WINDSZ                                                         |
rem + ------------------------------------------------------------------------ +
rem | V0.01, pjw, 2020 Feb 13                                                  |
rem + ------------------------------------------------------------------------ +
:
def proc Title(ch, aw%, txt$)
loc xs%, ys%, x%, y%, l%
mwindow#ch\ aw%
wm_paper#ch; sp_titlebg%: cls#ch
wm_ink#ch; sp_titlefg%
wm_strip#ch; sp_titletextbg%
windsz#ch; xs%, ys%, x%, y%
l% = len(txt$) * 6
x% = (xs% - l%) / 2
y% = (ys% - 12) / 2
wm_block#ch; l% + 8, 12, x% - 4, y%, sp_titletextbg%
cursor#ch; x% - 2, y% + 2: bput#ch; txt$
enddef Title
:
:
def proc Burp: if snd: beep 2000, 200: endif: enddef Burp
def proc Ping: if snd: beep 2000, 2: endif: enddef Ping
:
:
def fn Center$(txt$, w%)
loc t$(w%), ll%, l%
t$ = txt$: ll% = len(t$)
if ll% = w%: ret t$
l% = (w% - ll%) / 2
if (l% + l% + ll%) > w% then
 ret fill$(" ", l% - 1) & t$ & fill$(" ", l%)
else
 ret fill$(" ", l%) & t$ & fill$(" ", l%)
endif
enddef Center$
:
:
def fn Sz$(mg)
if mg < 0: ret Center$("-???", 10)
sel on mg
 =  0 to kb: ret cdec$(mg, 8, 0) & ' b'
 = kb to mb: ret cdec$(mg * mbb, 8, 2) & 'Kb'
 = mb to gb: ret cdec$(mg * gbb, 8, 2) & 'Mb'
endsel
ret cdec$(mg * tbb, 8, 2) & 'Gb'
end define Sz$
:
:
rem + ------------------------------------------------------------------------ +
rem |<                                Command Line                            >|
rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
rem |                    Parses command line and sets defaults                 |
rem |                                                                          |
rem |  /F file/Device name                                                     |
rem |  /P palette 0..3, address (hex). Owner must own space at address!        |
rem |  /S Sound on/off                                                         |
rem |  /W Width of display in pixels. Decimal                                  |
rem |  /X X-position, and                                                      |
rem |  /Y Y-position, in pixels. Decimal                                       |
rem |                                                                          |
rem | External: Getent$ reads GLOBal quote$                                    |
rem | Sets various GLOBal defaults (program-specific)                          |
rem + ------------------------------------------------------------------------ +
rem | V0.01, pjw, 2019 Jul 01                                                  |
rem | V0.02, pjw, 2020 Feb 14, standard code, modifyed for Qwirc Stats         |
rem + ------------------------------------------------------------------------ +
:
def fn GetCmd(cl$)
loc ch, p%, t$(200)
:
rem     GLOBal Defaults
snd             =   1
palette         =   0
win$            =  'win1_'
xpos%           =  -1
ypos%           = xpos%
wide%           = mn_wnx%
:
if len(cl$) = 0: ret -15
:
rem     Get device name
t$ = Getent$("D")
if t$ <> '': win$ = t$
:
rem     Do palette
t$ = Getent$("P")
if t$ <> '' then
 er = ValidHex(t$, palette)
 if er < 0: ret er
endif
SetPal
:
rem     Get gfx x/y position
t$ = Getent$("X")
if valid%(3, t$): xpos% = t$
t$ = Getent$("Y")
if valid%(3, t$): ypos% = t$
t$ = Getent$("W")
if valid%(3, t$): wide% = t$
if wide% < mn_wnx% then
 wide% = mn_wnx%
else
 if wide% > mx_wnx%: wide% = mx_wnx%
endif
:
ret 0
enddef GetCmd
:
def fn Getent$(c$)
rem Caller's cl$, p%, t$
rem Given the character get the entry
rem /C [<spaces>] ["|'] <entry> ["|'] <space> | <space> /C+1 | <eol>
:
p% = '/' & c$ instr cl$
if p% = 0: ret ''
t$ = detab$(cl$(p% + 2 to len(cl$)))
p% = ' /' instr t$
if p% > 0: t$ = t$(1 to p%): else: p% = len(t$)
for p% = len(t$) to 1 step -1
 if not t$(p%) instr ' /': exit p%
endfor p%
:
t$ = t$(1 to p%)
if len(t$) > 1 then
 p% = t$(1) instr quote$
 if p% then
  if (t$(len(t$)) instr quote$) = p% then
   t$ = t$(2 to len(t$) - 1)
  endif: endif: endif
ret t$
enddef Getent$
:
:
rem + ------------------------------------------------------------------------ +
rem |<                                 SetPal                                 >|
rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
rem | Standard basic SetPal, with address, but no file name                    |
rem + ------------------------------------------------------------------------ +
rem | V0.01, pjw, 2019                                                         |
rem + ------------------------------------------------------------------------ +
:
def proc Setpal
sel on palette
 = 0 to 3
 = remainder
   if odd(palette) or palette < 0 then
    palette = 0
   else
    sp_jobownpal -1, palette: rem Use calling job's private palette
    ret
   endif
endsel
sp_jobpal -1, palette:       rem Use system palette
enddef Setpal
:
:
rem + ------------------------------------------------------------------------ +
rem |<                                ValidHex                                >|
rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
rem |       Validate a hex string and return its decimal value or error        |
rem |                                                                          |
rem | Returns hex value in r.hx parameter!                                     |
rem | A valid hex number is of the form                                        |
rem |    [$]<hex digit>[<hex digit>] * 7                                       |
rem | Where [] => optional, and hex digits are 0..9, A..F, a..f                |
rem | The first non-hex charcter in an otherwise valid number terminates the   |
rem | the number but does not invalidate it!                                   |
rem | Numbers with more than 8 hex digits are truncated, but not invalidated!  |
rem + ------------------------------------------------------------------------ +
rem | V0.04, pjw, 2019 Dec 16, rewrite                                         |
rem + ------------------------------------------------------------------------ +
:
DEFine FuNction ValidHex(hx$, r.hx)
LOCal i%, d%, e%
d% = (('$' INSTR hx$) = 1) + 1
IF LEN(hx$) < d%: RETurn -15
e% = d% + 7
IF e% > LEN(hx$): e% = LEN(hx$)
FOR i% = d% TO e%
 IF NOT hx$(i%) INSTR '0123456789ABCDEF': e% = i% - 1: EXIT i%
END FOR i%
IF e% < d%: RETurn -15
r.hx = HEX(hx$(d% TO e%))
RETurn 0
END DEFine ValidHex
:
:
